Debian Bug report logs - #689085
libtiff4-dev is not Multi-Arch compatible

version graph

Package: libtiff5-alt-dev; Maintainer for libtiff5-alt-dev is Jay Berkenbilt <qjb@debian.org>; Source for libtiff5-alt-dev is src:tiff.

Reported by: Francois Gouget <fgouget@free.fr>

Date: Sat, 29 Sep 2012 00:33:01 UTC

Severity: normal

Found in version tiff/4.0.3-2

Fixed in version tiff/4.0.3-4

Done: Jay Berkenbilt <qjb@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Jay Berkenbilt <qjb@debian.org>:
Bug#689085; Package libtiff4-dev. (Sat, 29 Sep 2012 00:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Francois Gouget <fgouget@free.fr>:
New Bug report received and forwarded. Copy sent to Jay Berkenbilt <qjb@debian.org>. (Sat, 29 Sep 2012 00:33:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Francois Gouget <fgouget@free.fr>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libtiff4-dev is not Multi-Arch compatible
Date: Sat, 29 Sep 2012 02:31:43 +0200
Package: libtiff4-dev
Version: 3.9.6-7
Severity: normal

Dear Maintainer,

The amd64 version conflicts with the i386 one which makes it impossible to install both. As a result the /usr/lib/i386-linux-gnu/libtiff.so symbolic link is missing so that developping 32bit applications using this library is impossible on a 64bit system.

Furthermore this development package does not seem to be multiarch aware as there is no Multi-Arch field.

My understanding is that as long as there are no architecture-dependent headers there is no obstacle (i.e. no toolchain issue) to tagging the development package as 'Multi-Arch: same'. The symbolic link (and any static libraries) should be no issue as they are already in the architecture-qualified folders.

A good model for this appears to be the libx11-dev package.

-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (500, 'testing'), (500, 'stable')
Architecture: amd64 (x86_64)
Foreign Architectures: i386

Kernel: Linux 3.2.0-3-amd64 (SMP w/4 CPU cores)
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libtiff4-dev depends on:
ii  libc6-dev [libc-dev]        2.13-35
ii  libjbig-dev                 2.0-2
ii  libjpeg8-dev [libjpeg-dev]  8d-1
ii  libtiff4                    3.9.6-7
ii  libtiffxx0c2                3.9.6-7
ii  zlib1g-dev                  1:1.2.7.dfsg-13

libtiff4-dev recommends no packages.

libtiff4-dev suggests no packages.

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#689085; Package libtiff4-dev. (Mon, 01 Oct 2012 14:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jay Berkenbilt <qjb@debian.org>:
Extra info received and forwarded to list. (Mon, 01 Oct 2012 14:51:03 GMT) Full text and rfc822 format available.

Message #10 received at 689085@bugs.debian.org (full text, mbox):

From: Jay Berkenbilt <qjb@debian.org>
To: Francois Gouget <fgouget@free.fr>
Cc: 689085@bugs.debian.org
Subject: Re: Bug#689085: libtiff4-dev is not Multi-Arch compatible
Date: Mon, 01 Oct 2012 10:39:51 -0400
Francois Gouget <fgouget@free.fr> wrote:

> The amd64 version conflicts with the i386 one which makes it
> impossible to install both. As a result the
> /usr/lib/i386-linux-gnu/libtiff.so symbolic link is missing so that
> developping 32bit applications using this library is impossible on a
> 64bit system.
>
> Furthermore this development package does not seem to be multiarch
> aware as there is no Multi-Arch field.
>
> My understanding is that as long as there are no
> architecture-dependent headers there is no obstacle (i.e. no toolchain
> issue) to tagging the development package as 'Multi-Arch: same'. The
> symbolic link (and any static libraries) should be no issue as they
> are already in the architecture-qualified folders.

Unfortunately, libtiff-dev does actually contain an
architecture-dependent header file, so Multi-Arch: same would not be
appropriate.  If you extract and diff the i386 and amd64 versions of
libtiff5-dev, you will notice that tiffconf.h contains
architecture-dependent definitions of TIFF_INT64_T and TIFF_UINT64_T.
For libtiff4-dev, tiffconf.h contains a definition of SIZEOF_LONG.  Both
of these architecture-dependencies could be avoided by upstream, but
they are there, so I can't use 'Multi-Arch: same'.  I'm not sure whether
there is some other way to handle this right now other than to patch.
In the libtiff4-dev case, the code should just use sizeof long rather
than defining its value (though maybe there are static definitions of
things to be a certain size -- the code would have to be inspected).
For libtiff5, we could patch so that we use stdint.h (which doesn't
exist everywhere libtiff works but does on all debian platforms) and
define TIFF_*INT64_T in terms of int64_t and uint64_t, but this requires
a bigger change than just editing debian/control.

-- 
Jay Berkenbilt <qjb@debian.org>



Reply sent to Jay Berkenbilt <qjb@debian.org>:
You have taken responsibility. (Sat, 17 Nov 2012 19:51:06 GMT) Full text and rfc822 format available.

Notification sent to Francois Gouget <fgouget@free.fr>:
Bug acknowledged by developer. (Sat, 17 Nov 2012 19:51:06 GMT) Full text and rfc822 format available.

Message #15 received at 689085-done@bugs.debian.org (full text, mbox):

From: Jay Berkenbilt <qjb@debian.org>
To: 689085-done@bugs.debian.org
Subject: closing bug
Date: Sat, 17 Nov 2012 14:49:01 -0500
I'm closing this bug because the problem can't be fixed as described.

-- 
Jay Berkenbilt <qjb@debian.org>



Information forwarded to debian-bugs-dist@lists.debian.org, Jay Berkenbilt <qjb@debian.org>:
Bug#689085; Package libtiff4-dev. (Sat, 17 Nov 2012 23:57:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Francois Gouget <fgouget@free.fr>:
Extra info received and forwarded to list. Copy sent to Jay Berkenbilt <qjb@debian.org>. (Sat, 17 Nov 2012 23:57:05 GMT) Full text and rfc822 format available.

Message #20 received at 689085@bugs.debian.org (full text, mbox):

From: Francois Gouget <fgouget@free.fr>
To: 689085@bugs.debian.org
Subject: Re: Bug#689085 closed by Jay Berkenbilt <qjb@debian.org> (closing bug)
Date: Sun, 18 Nov 2012 00:52:56 +0100 (CET)
On Sat, 17 Nov 2012, Debian Bug Tracking System wrote:

> This is an automatic notification regarding your Bug report
> which was filed against the libtiff4-dev package:
> 
> #689085: libtiff4-dev is not Multi-Arch compatible
> 
> It has been closed by Jay Berkenbilt <qjb@debian.org>.
> 
> Their explanation is attached below along with your original report.
[...]
>I'm closing this bug because the problem can't be fixed as described.

My bug report was not about thoughtlessly setting 'Multi-Arch: same' 
but rather more about making libtiff4-dev multiarch compatible.

Or do you mean that your plan is to never make libtiff4-dev multiarch 
compatible?

-- 
Francois Gouget <fgouget@free.fr>              http://fgouget.free.fr/
                        question = ( to ) ? be : ! be;
                              -- Wm. Shakespeare



Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#689085; Package libtiff4-dev. (Sun, 18 Nov 2012 19:06:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jay Berkenbilt <qjb@debian.org>:
Extra info received and forwarded to list. (Sun, 18 Nov 2012 19:06:02 GMT) Full text and rfc822 format available.

Message #25 received at 689085@bugs.debian.org (full text, mbox):

From: Jay Berkenbilt <qjb@debian.org>
To: Francois Gouget <fgouget@free.fr>
Cc: 689085@bugs.debian.org
Subject: Re: Bug#689085: closed by Jay Berkenbilt <qjb@debian.org> (closing bug)
Date: Sun, 18 Nov 2012 14:04:06 -0500
Francois Gouget <fgouget@free.fr> wrote:

> On Sat, 17 Nov 2012, Debian Bug Tracking System wrote:
>
> My bug report was not about thoughtlessly setting 'Multi-Arch: same'
> but rather more about making libtiff4-dev multiarch compatible.

Sorry, I didn't mean to imply that you were suggesting doing anything
thoughtlessly, just that the original phrase "as long as there are no
architecture-dependent headers" did not apply.

> Or do you mean that your plan is to never make libtiff4-dev multiarch
> compatible?

My plan is not to do it if upstream is not going to do it.  Upstream
development on libtiff is very light since no one is working on it full
time.  Pretty much the only changes that are made are changes for which
patches are supplied.  In order for tiff headers to be architecture
independent, /usr/include/tiffconf.h would have to no longer be
installed.  Upstream already knows that this is a bad thing to have
done, and there are comments in the header that say the file is
maintained for backward compatibility and definitions from it should not
be used by end user programs.  However, there is no way to know whether
these definitions are used, and they probably are, so removing it would
potentially break source compatibility.  Given that this issue was not
resolved during the recent release of tiff 4, which was disruptive
because of its non-compatible changes (hence there still being two
versions of tiff in wheezy), and given that tiff.h includes tiffconf.h
and uses definitions from it, I don't believe this is likely to be
fixed.  While it would not be that hard to make the tiff package itself
work without this file, there is a lot of code out there that could
break.

So, the bottom line is that I have no intention of addressing this
issue, or as you put it, my plan is to never make libtiff4-dev multiarch
compatible.  It's not about laziness or being contrary; it's just that
it's more than I have the time or inclination to tackle, particularly
since doing this would be a deviation from upstream.

That said, if someone wishes to provide a simple solution that doesn't
involve creating a situation where debian's tiff is not
source-compatible with straight upstream or tiff on other distributions,
I would consider it.  I just don't see any such solution existing given
that there's no way to really know who depends on things defined in
tiffconf.h that they get indirectly by including tiff.h, which must be
included by all code that uses the tiff library.

For some of my open source work, I went to effort from the beginning to
avoid this pitfall.  Sadly, xerces-c, which I also maintain, also
suffers from the same problem as tiff: files generated by autoconf are
installed, which prevents using Multi-Arch: same in the dev package.

-- 
Jay Berkenbilt <qjb@debian.org>



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 17 Dec 2012 07:28:26 GMT) Full text and rfc822 format available.

Bug unarchived. Request was from Jay Berkenbilt <qjb@debian.org> to control@bugs.debian.org. (Fri, 23 Aug 2013 20:45:04 GMT) Full text and rfc822 format available.

Bug reassigned from package 'libtiff4-dev' to 'libtiff5-alt-dev'. Request was from Jay Berkenbilt <qjb@debian.org> to control@bugs.debian.org. (Fri, 23 Aug 2013 20:45:04 GMT) Full text and rfc822 format available.

No longer marked as found in versions tiff3/3.9.6-7. Request was from Jay Berkenbilt <qjb@debian.org> to control@bugs.debian.org. (Fri, 23 Aug 2013 20:45:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#689085; Package libtiff5-alt-dev. (Fri, 23 Aug 2013 20:51:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jay Berkenbilt <qjb@debian.org>:
Extra info received and forwarded to list. (Fri, 23 Aug 2013 20:51:04 GMT) Full text and rfc822 format available.

Message #38 received at 689085@bugs.debian.org (full text, mbox):

From: Jay Berkenbilt <qjb@debian.org>
To: 689085@bugs.debian.org
Cc: 689085-submitter@bugs.debian.org
Subject: multi-arch conversion for tiff
Date: Fri, 23 Aug 2013 16:47:54 -0400
I recently became aware of being able to install headers in an
architecture-specific location and improved my understanding of how to
use Multi-Arch: foreign as part of this process.  I'm not sure exactly
how I missed this the first time around.  In any case, I now believe I
can complete the conversion of the tiff packages to multi-arch.

More likely than not, I will only convert the newer tiff packages to
multi-arch and not the old tiff3 packages, but I might be open to being
convinced otherwise.

-- 
Jay Berkenbilt <qjb@debian.org>



Message sent on to Francois Gouget <fgouget@free.fr>:
Bug#689085. (Fri, 23 Aug 2013 20:51:11 GMT) Full text and rfc822 format available.

Bug reopened Request was from Jay Berkenbilt <qjb@debian.org> to control@bugs.debian.org. (Sat, 24 Aug 2013 15:15:04 GMT) Full text and rfc822 format available.

Marked as found in versions tiff/4.0.3-2. Request was from Jay Berkenbilt <qjb@debian.org> to control@bugs.debian.org. (Sat, 24 Aug 2013 15:15:05 GMT) Full text and rfc822 format available.

Bug 689085 cloned as bug 720705 Request was from Jay Berkenbilt <qjb@debian.org> to control@bugs.debian.org. (Sat, 24 Aug 2013 16:21:11 GMT) Full text and rfc822 format available.

Reply sent to Jay Berkenbilt <qjb@debian.org>:
You have taken responsibility. (Wed, 28 Aug 2013 17:09:05 GMT) Full text and rfc822 format available.

Notification sent to Francois Gouget <fgouget@free.fr>:
Bug acknowledged by developer. (Wed, 28 Aug 2013 17:09:05 GMT) Full text and rfc822 format available.

Message #52 received at 689085-close@bugs.debian.org (full text, mbox):

From: Jay Berkenbilt <qjb@debian.org>
To: 689085-close@bugs.debian.org
Subject: Bug#689085: fixed in tiff 4.0.3-4
Date: Wed, 28 Aug 2013 17:04:53 +0000
Source: tiff
Source-Version: 4.0.3-4

We believe that the bug you reported is fixed in the latest version of
tiff, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 689085@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jay Berkenbilt <qjb@debian.org> (supplier of updated tiff package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 24 Aug 2013 11:50:20 -0400
Source: tiff
Binary: libtiff5 libtiffxx5 libtiff5-dev libtiff5-alt-dev libtiff-tools libtiff-opengl libtiff-doc
Architecture: source all amd64
Version: 4.0.3-4
Distribution: unstable
Urgency: low
Maintainer: Jay Berkenbilt <qjb@debian.org>
Changed-By: Jay Berkenbilt <qjb@debian.org>
Description: 
 libtiff-doc - TIFF manipulation and conversion documentation
 libtiff-opengl - TIFF manipulation and conversion tools
 libtiff-tools - TIFF manipulation and conversion tools
 libtiff5   - Tag Image File Format (TIFF) library
 libtiff5-alt-dev - Tag Image File Format library (TIFF), alternative development fil
 libtiff5-dev - Tag Image File Format library (TIFF), development files
 libtiffxx5 - Tag Image File Format (TIFF) library -- C++ interface
Closes: 689085
Changes: 
 tiff (4.0.3-4) unstable; urgency=low
 .
   * Complete Multi-Arch conversion for dev packages.  (Closes: #689085)
Checksums-Sha1: 
 94b11d5005a0f1677f7dcf92b3695160912623aa 2139 tiff_4.0.3-4.dsc
 35db57b0b100b968b1b7b13c113c96aa6dfa45ee 22240 tiff_4.0.3-4.debian.tar.gz
 82943b81bec8ad86fffc13d86079f140d28be3b8 362020 libtiff-doc_4.0.3-4_all.deb
 836beb302899a78671d681e1bc7f21a3db781347 207126 libtiff5_4.0.3-4_amd64.deb
 d241563ce665892a749e5e09b6d629ee0477693f 73474 libtiffxx5_4.0.3-4_amd64.deb
 70e43bdec1d43681799aa953ff4dfebf002ce21b 330316 libtiff5-dev_4.0.3-4_amd64.deb
 0504ef8a61211d22083524c7e7936ad6955d8be5 242590 libtiff5-alt-dev_4.0.3-4_amd64.deb
 4464ef20eb726a1660de556eda3ff40b808de3a0 282218 libtiff-tools_4.0.3-4_amd64.deb
 995d927c369fac142900e85234c5666b0b5b4528 78606 libtiff-opengl_4.0.3-4_amd64.deb
Checksums-Sha256: 
 1b467f36a5dd12993d7b8ff04893f2d15155cd5b51ff8af5baeccf5e14fe2572 2139 tiff_4.0.3-4.dsc
 d727b6e9df35ca89fc580a60e94e0563b1398fc222878a6bc065de9cb521c3f9 22240 tiff_4.0.3-4.debian.tar.gz
 39704e7e5492df568749e7b7da3b17a73b83f27fb41d406b78faf3febb566ac8 362020 libtiff-doc_4.0.3-4_all.deb
 1f882b8f1aaa14b345b0f560ecff25fd77a3df809e5259ee064c2a0956e04383 207126 libtiff5_4.0.3-4_amd64.deb
 530bd1d062ec7538457ddfa1579b2e4f0104180bca568dc7b0bb27fd4648f2d9 73474 libtiffxx5_4.0.3-4_amd64.deb
 7a4a340d3cb2ddb0c69f4ba27b978976ff72857dbc1e8c1bff6eba9cf4460e4d 330316 libtiff5-dev_4.0.3-4_amd64.deb
 e99b8b6bb320d783aa9b68a058fedfed712145d539b23fa425cc7f126e97893c 242590 libtiff5-alt-dev_4.0.3-4_amd64.deb
 96d512bda1981ccef76b89ef186b48d63b4f24b25fcd54758eeda4d7def673d6 282218 libtiff-tools_4.0.3-4_amd64.deb
 a15067a87e684e5d6693ad58a36a4788f0f5a92df578c939486db2a384627190 78606 libtiff-opengl_4.0.3-4_amd64.deb
Files: 
 6d3bccd29fcc0c956d24811c88f1d9d9 2139 libs optional tiff_4.0.3-4.dsc
 13648c691ae6e8a071b0f8426d64aa86 22240 libs optional tiff_4.0.3-4.debian.tar.gz
 e4564428139354d99ee6807710868498 362020 doc optional libtiff-doc_4.0.3-4_all.deb
 5ec8102a2a0c9bcc86632ebc933a928e 207126 libs optional libtiff5_4.0.3-4_amd64.deb
 26a615e6287c5e42d6746d8577779b86 73474 libs optional libtiffxx5_4.0.3-4_amd64.deb
 f8f75077d5d4d51a13d5579989036f37 330316 libdevel optional libtiff5-dev_4.0.3-4_amd64.deb
 217f3f1fdccd1d6a443fe012ba800cef 242590 libdevel optional libtiff5-alt-dev_4.0.3-4_amd64.deb
 c41fa9f961ab7bdbfd324bd55d96198a 282218 graphics optional libtiff-tools_4.0.3-4_amd64.deb
 c61457acfcba98e7211962f9e9aaad28 78606 graphics optional libtiff-opengl_4.0.3-4_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.14 (GNU/Linux)

iQIcBAEBAgAGBQJSHiv+AAoJEIp10QmYASx+AacP+gK5Zxe7us07Ctdu0w0xhQ2n
jghEi2YkC9lDCApSV5MLr7ZD/k3xxxcCNnbgWaVx27+BMCVB+XafP3Exi8JMgz5y
DVFNx+7bRcox4HwuqPDa6XpnwvtG4/i7M0yhLnBD2d41BKfcq6CVJNjpcuAuZeJN
++SJKBu5H1bEbcHKLXIsJ0x8a5cn5hxBXhhm8ebyCLga4oqoYvv95mIj4QJkVZSP
zj1iKrTMAFrrDntqUe4BJhvQbQOISfzI/g7iyyQYV0YboOFM6uq053wpCRp1jl+8
Uk7Ap14CRRPxTb7mz4+Q4hRMlkni4Z2+1u6MGwyNkjMRE7gb8cxFMQ0D++JOsN84
rvi92KfmkPr6QZhsSyCqLlveqX4Dm0Ad9KysIkZngJAsKZCAZqhi9AzUkrxJ3OIO
XYZbl2i1E3V48QLzY5bl/RfM3Ncn0YTdmBuz02Dj4Gpgdv60OQAG7cejSlKg5OEG
YvQbu/jb+YW/ITBu0uNCWezKczm2auG/3DH3MJRONEm0AvVPxPcR0BkgO/t/Ga1+
GiIZzDOclSUFrPmg3i1Ek/guKL4M32RvwMtc9kGj2XpWNDdHc1DpjYOq1T1chM7o
EbCBpp8VgSJR6xa8MukZA0tw8e+HbGp8L4ohKKwj/7k5oWhHZWeuU5h3cW3e/Ydy
fj2mQ65yCm7dg06jeyC9
=B8HG
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 06 Oct 2013 07:37:42 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 06:41:51 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.